<?php
/***************************************************************************
 *                              admin_ezdloads.php
 *                            -------------------
 *   begin                : Saturday, November 6, 2004
 *   copyright            : (C) 2004 HerrBawl Technologies
 *   email                : admin@herrbawl.com
 *
 ***************************************************************************/
 
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['Downloads']['Configuration'] = $file . "?mode=config";
	$module['Downloads']['DL_Select_Forum'] = $file . "?mode=forums";
	return;
}

$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'includes/functions_selects.'.$phpEx);

$template->set_filenames(array(
	"body_config" => "admin/ezdloads_config_body.tpl",
	"body_forums" => "admin/ezdloads_forums_body.tpl")
);

function get_cfg($name)
{
	global $db;
	$sql = 'SELECT `config_name` , `config_value` ';
	$sql .= 'FROM `' . CONFIG_TABLE . '` ';
	$sql .= 'WHERE `config_name` = \'' . $name . '\'';
	
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	return $row['config_value'];
};

function set_cfg($name, $value)
{
	global $db;
	$sql = 'UPDATE `' . CONFIG_TABLE . '` ';
	$sql .= 'SET `config_value` = \'' . $value . '\' ';
	$sql .= 'WHERE `config_name` = \'' . $name . '\' ';	
	$result = $db->sql_query($sql);
	return;
};

function get_forum_info()
{
	global $db;
	$sql = 'SELECT `forum_id` , `forum_name` , `dload_check` ';
	$sql .= 'FROM `' . FORUMS_TABLE . '` ';
	
	$result = $db->sql_query($sql);
	
	$forums = array();
		
	if ($row = $db->sql_fetchrow($result))
	{
		$i = 0;
		do
		{
			$forums[$i]['id'] = $row['forum_id'];
			$forums[$i]['name'] = $row['forum_name'];
			$forums[$i]['check'] = $row['dload_check'];
			$i++;
		}
		while ($row = $db->sql_fetchrow($result));
	};
	
	return $forums;
};

function set_forum_info($fid, $checked)
{
	global $db;
	$sql = 'UPDATE `' . FORUMS_TABLE . '` ';
	$sql .= 'SET `dload_check` = \'' . $checked . '\' ';
	$sql .= 'WHERE `forum_id` = \'' . $fid . '\' ';	
	$result = $db->sql_query($sql);
	return;
};

function is_checked($value)
{
	if( $value == 'on' )
	{
		return true;
	}
	else
	{
		return false;
	};
};

include_once('./page_header_admin.'.$phpEx);
			
if( $userdata['session_logged_in'] )
{
	if( $userdata['user_level'] == ADMIN )
	{
		if( $HTTP_GET_VARS['mode'] == 'updatecfg' )
		{
			if( $HTTP_POST_VARS['root'] == $lang['DL_Root_Only'] )
			{
				set_cfg('dload_root', '0');
			}
			else
			{
				set_cfg('dload_root', '1');
			};
			switch( $HTTP_POST_VARS['pag'] )
			{
				case $lang['DL_Pag_None']:
					set_cfg('dload_pag','0');
					break;
				case $lang['DL_Pag_Per_Page']:
					set_cfg('dload_pag','1');
					break;
				case $lang['DL_Pag_Indexed']:
					set_cfg('dload_pag','2');
					break;
			};
			set_cfg('dload_perpag_num', $HTTP_POST_VARS['perpag_num']);
			switch( $HTTP_POST_VARS['perpag_type'] )
			{
				case $lang['DL_PerPag_Cat']:
					set_cfg('dload_perpag_type', '0');
					break;
				case $lang['DL_PerPag_SubCat']:
					set_cfg('dload_perpag_type', '1');
					break;
				case $lang['DL_PerPag_DL']:
					set_cfg('dload_perpag_type', '2');
					break;
			};
			if( $HTTP_POST_VARS['folder'] == $lang['DL_Folder_Disabled'] )
			{
				set_cfg('dload_folder', '0');
			}
			else
			{
				set_cfg('dload_folder', '1');
			};
			set_cfg('dload_dir', addslashes($HTTP_POST_VARS['dir']));
			if( is_checked($HTTP_POST_VARS['sub']) )
			{
				set_cfg('dload_dir_sub', '1');
			}
			else
			{
				set_cfg('dload_dir_sub', '0');
			};
			if( $HTTP_POST_VARS['search'] == $lang['DL_Search_Disallow'] )
			{
				set_cfg('dload_search', '0');
			}
			else
			{
				set_cfg('dload_search', '1');
			};
			if( $HTTP_POST_VARS['comment'] == $lang['DL_Comm_All'] )
			{
				set_cfg('dload_comm', '0');
			}
			else
			{
				set_cfg('dload_comm', '1');
			};
			echo "<HTML><HEAD>";
			echo "<META HTTP-EQUIV=\"refresh\" content=\"0;URL=" . append_sid("admin_ezdloads." . $phpEx . "?mode=config") . "\">";
			echo "</HEAD><BODY><h1>" . $lang['DL_Config_Update_Status'] . "</h1></BODY></HTML>";
		};
		if( $HTTP_GET_VARS['mode'] == 'updatefrm' )
		{
			$forums = get_forum_info();
			for ($i = 0; $i < count($forums); $i++)
			{
				if( is_checked($HTTP_POST_VARS[$forums[$i]['id']]) )
				{
					set_forum_info($forums[$i]['id'], '1');
				}
				else
				{
					set_forum_info($forums[$i]['id'], '0');
				};				
			};
			echo "<HTML><HEAD>";
			echo "<META HTTP-EQUIV=\"refresh\" content=\"0;URL=" . append_sid("admin_ezdloads." . $phpEx . "?mode=forums") . "\">";
			echo "</HEAD><BODY><h1>" . $lang['DL_Forums_Update_Status'] . "</h1></BODY></HTML>";
		};
		if( $HTTP_GET_VARS['mode'] == 'config' )
		{
			$template->assign_vars(array(
				"ACTION" => append_sid("admin_ezdloads." . $phpEx . "?mode=updatecfg"),
				"TITLE" => $lang['DL_Config_Title'],
				"ROOT_TITLE" => $lang['DL_Root_Title'],
				"ROOT_EXPLAIN" => $lang['DL_Root_Explain'],
				"SRCH_TITLE" => $lang['DL_Search_Title'],
				"SRCH_EXPLAIN" => $lang['DL_Search_Explain'],
				"PAG_TITLE" => $lang['DL_Pag_Title'],
				"PAG_EXPLAIN" => $lang['DL_Pag_Explain'],
				"COMM_TITLE" => $lang['DL_Comm_Title'],
				"COMM_EXPLAIN" => $lang['DL_Comm_Explain'],
				"PERPAG_TITLE" => $lang['DL_PerPag_Title'],
				"PERPAG_EXPLAIN" => $lang['DL_PerPag_Explain'],
				"FLDR_TITLE" => $lang['DL_Folder_Title'],
				"FLDR_EXPLAIN" => $lang['DL_Folder_Explain'],
				"FLDR_DIR" => stripslashes(get_cfg('dload_dir')),
				"FLDR_DIR_TITLE" => $lang['DL_Folder_Dir_Title'],
				"FLDR_DIR_EXPLAIN" => $lang['DL_Folder_Dir_Explain'],
				"FLDR_DIR_SUB" => $lang['DL_Folder_Dir_Sub'],
				"RESET" => $lang['DL_Reset'],
				"UPDATE" => $lang['DL_Config_Update'],
				"PERPAG_AFTER" => $lang['DL_PerPag_After'],
				"PERPAG_NUM" => get_cfg('dload_perpag_num'))
			);
			if( get_cfg('dload_root') == "0" )
			{
				$template->assign_vars(array(
					"ROOT_CHOICE_1" => $lang['DL_Root_Only'],
					"ROOT_CHOICE_2" => $lang['DL_Root_Replies'])
				);
			}
			else
			{
				$template->assign_vars(array(
					"ROOT_CHOICE_1" => $lang['DL_Root_Replies'],
					"ROOT_CHOICE_2" => $lang['DL_Root_Only'])
				);
			};
			switch( get_cfg('dload_pag') )
			{
				case "0":
					$template->assign_vars(array(
						"PAG_CHOICE_1" => $lang['DL_Pag_None'],
						"PAG_CHOICE_2" => $lang['DL_Pag_Per_Page'],
						"PAG_CHOICE_3" => $lang['DL_Pag_Indexed'])
					);
					break;
				case "1":
					$template->assign_vars(array(
						"PAG_CHOICE_1" => $lang['DL_Pag_Per_Page'],
						"PAG_CHOICE_2" => $lang['DL_Pag_Indexed'],
						"PAG_CHOICE_3" => $lang['DL_Pag_None'])
					);
					break;
				case "2":
					$template->assign_vars(array(
						"PAG_CHOICE_1" => $lang['DL_Pag_Indexed'],
						"PAG_CHOICE_2" => $lang['DL_Pag_None'],
						"PAG_CHOICE_3" => $lang['DL_Pag_Per_Page'])
					);
					break;
			};
			switch( get_cfg('dload_perpag_type') )
			{
				case "0":
					$template->assign_vars(array(
						"PERPAG_CHOICE_1" => $lang['DL_PerPag_Cat'],
						"PERPAG_CHOICE_2" => $lang['DL_PerPag_SubCat'],
						"PERPAG_CHOICE_3" => $lang['DL_PerPag_DL'])
					);
					break;
				case "1":
					$template->assign_vars(array(
						"PERPAG_CHOICE_1" => $lang['DL_PerPag_SubCat'],
						"PERPAG_CHOICE_2" => $lang['DL_PerPag_DL'],
						"PERPAG_CHOICE_3" => $lang['DL_PerPag_Cat'])
					);
					break;
				case "2":
					$template->assign_vars(array(
						"PERPAG_CHOICE_1" => $lang['DL_PerPag_DL'],
						"PERPAG_CHOICE_2" => $lang['DL_PerPag_Cat'],
						"PERPAG_CHOICE_3" => $lang['DL_PerPag_SubCat'])
					);
					break;
			};
			if( get_cfg('dload_folder') == "0" )
			{
				$template->assign_vars(array(
					"FLDR_CHOICE_1" => $lang['DL_Folder_Disabled'],
					"FLDR_CHOICE_2" => $lang['DL_Folder_Enabled'])
				);
			}
			else
			{
				$template->assign_vars(array(
					"FLDR_CHOICE_1" => $lang['DL_Folder_Enabled'],
					"FLDR_CHOICE_2" => $lang['DL_Folder_Disabled'])
				);
			};
			if( get_cfg('dload_dir_sub') == '1' )
			{
				$template->assign_vars(array(
					"FLDR_DIR_SUB_CHECKED" => 'checked')
				);
			};
			if( get_cfg('dload_search') == "0" )
			{
				$template->assign_vars(array(
					"SRCH_CHOICE_1" => $lang['DL_Search_Disallow'],
					"SRCH_CHOICE_2" => $lang['DL_Search_Allow'])
				);
			}
			else
			{
				$template->assign_vars(array(
					"SRCH_CHOICE_1" => $lang['DL_Search_Allow'],
					"SRCH_CHOICE_2" => $lang['DL_Search_Disallow'])
				);
			};
			if( get_cfg('dload_comm') == "0" )
			{
				$template->assign_vars(array(
					"COMM_CHOICE_1" => $lang['DL_Comm_All'],
					"COMM_CHOICE_2" => $lang['DL_Comm_Logged'])
				);
			}
			else
			{
				$template->assign_vars(array(
					"COMM_CHOICE_1" => $lang['DL_Comm_Logged'],
					"COMM_CHOICE_2" => $lang['DL_Comm_All'])
				);
			};
			$template->pparse("body_config");
		};
		if( $HTTP_GET_VARS['mode'] == 'forums' )
		{
			$template->assign_vars(array(
				"ACTION" => append_sid("admin_ezdloads." . $phpEx . "?mode=updatefrm"),
				"NONE" => $lang['DL_Forum_None'],
				"TITLE" => $lang['DL_Forums_Title'],
				"EXPLAIN" => $lang['DL_Forums_Explain'],
				"FORUM_NAME" => $lang['DL_Forum_Name'],
				"FORUM_CHECK" => $lang['DL_Forum_Check'],
				"UPDATE" => $lang['DL_Forums_Update'],
				"RESET" => $lang['DL_Reset'])
			);
			$forums = get_forum_info();
			if( count($forums) > 0 )
			{
				$template->assign_block_vars('dl', array());
				$cols = 0;
				for ($i = 0; $i < count($forums); $i++)
				{
					if( $cols == 0 )
					{
						$template->assign_block_vars('dl.row', array());
						$cols = 1;
					}
					else
					{
						$cols = 0;
					};
					$ischecked = '';
					if( $forums[$i]['check'] == '1' )
					{
						$ischecked = ' checked';
					};
					$template->assign_block_vars('dl.row.forum', array(
						"name" => $forums[$i]['name'],
						"id" => $forums[$i]['id'],
						"check" => $ischecked)
					);					
				};
				if( $cols == 1 )
				{
					$template->assign_block_vars('dl.row.empty_forum', array());
				};
			}
			else
			{
				$template->assign_block_vars('no_dl', array());
			};
			$template->pparse("body_forums");
		};
	}
}

include('./page_footer_admin.'.$phpEx);

?>
